////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform mat4 mBlendMatrix;
uniform int mCutoutType;

vec4 getShowColorWithTranslucenta(vec4 srcColor, vec4 maskColor) {
    vec4 translucentaColor = vec4(0, 0, 0, 1.0);
    vec4 blendColor = translucentaColor * (1.0 - maskColor.a) * 0.5;
    return srcColor * (1.0 - blendColor.a) + blendColor;
}

void main()
{
    vec4 srcColor = texture2D(inputImageTexture, textureCoordinate);
    vec4 coordinate = vec4(textureCoordinate, 0., 1.);
    coordinate = mBlendMatrix * coordinate;
    vec4 maskColor = texture2D(inputImageTexture2, coordinate.xy);
    if (mCutoutType == 1 && (coordinate.x < 0.0 || coordinate.x > 1.0 || coordinate.y < 0.0 || coordinate.y > 1.0)) {
        gl_FragColor = srcColor;
        return;
    }
    if (mCutoutType == 2) {
        // shape 裁剪+预览
        gl_FragColor = getShowColorWithTranslucenta(srcColor, maskColor);
    } else if (mCutoutType == 3) {
        //反色，添加后，取的百分比越多，想接近白色
        vec4 translucenta = vec4(srcColor.rgb * 0.6 + (1. - srcColor.rgb) * 0.3, 0.85);
        gl_FragColor = srcColor * maskColor.a + translucenta * (1. - maskColor.a) * srcColor.a;
    } else if (mCutoutType == 4 || mCutoutType == 1) {
        gl_FragColor = srcColor * maskColor.a;
    } else if (mCutoutType == 5 || mCutoutType == 7) {
//        float testA = maskColor.r<1.0 ? clamp(maskColor.r * 2.0) : maskColor.r;

        gl_FragColor = srcColor *maskColor.r ;
    } else if (mCutoutType == 6) {
        vec4 translucenta = vec4(srcColor.rgb * 0.6 + (1. - srcColor.rgb) * 0.3, 0.85);
        gl_FragColor = srcColor * maskColor.r + translucenta * (1. - maskColor.r) * srcColor.a;
    } else {
        gl_FragColor = srcColor;
    }
}