////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
varying highp vec2 textureCoordinate3;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

uniform mat4 mBlendMatrix;
uniform lowp float intensity;
uniform int frontBackType;
uniform int showBlendInTranslparent;

vec4 normalBlend(vec4 d, vec4 s) {
    vec4 c;
    c.r = s.r + d.r * d.a * (1.0 - s.a);
    c.g = s.g + d.g * d.a * (1.0 - s.a);
    c.b = s.b + d.b * d.a * (1.0 - s.a);
    c.a = s.a + d.a * (1.0 - s.a);
    return c;
}

void main()
{
    vec4 coordinate=vec4(textureCoordinate, 0., 1.);
    coordinate= mBlendMatrix * coordinate;
    if (coordinate.x<0.||coordinate.x>1.||coordinate.y<0.||coordinate.y>1.){
        gl_FragColor=texture2D(inputImageTexture, textureCoordinate);
        return;
    }
    mediump vec4 blendColor = texture2D(inputImageTexture2, coordinate.xy) ;
    mediump vec4 maskColor= vec4(0.0);
    if (frontBackType != 0){
        maskColor=texture2D(inputImageTexture3, textureCoordinate);
    }
    mediump vec4 srcColor = texture2D(inputImageTexture, textureCoordinate);

    if(showBlendInTranslparent == 0){
        blendColor =  blendColor * srcColor.a ;
    }
    float alpha= 1.- maskColor.a;
    blendColor = blendColor  * alpha * intensity;

    gl_FragColor= normalBlend(srcColor,blendColor);

}