////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
varying highp vec2 textureCoordinate3;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

uniform mat4 mBlendMatrix;
uniform lowp float intensity;
uniform int frontBackType;
uniform int showBlendInTranslparent;


float blendSoftLight(float base, float blend) {
    return (blend < 0.5) ? (2.0 * base * blend + base * base * (1.0 - 2.0 * blend)) : (sqrt(base) * (2.0 * blend - 1.0) + 2.0 * base * (1.0 - blend));
}

vec3 blendSoftLight(vec3 base, vec3 blend) {
    return vec3(blendSoftLight(base.r, blend.r), blendSoftLight(base.g, blend.g), blendSoftLight(base.b, blend.b));
}

vec3 blendSoftLight(vec3 base, vec3 blend, float opacity) {
    return (blendSoftLight(base, blend) * opacity + base * (1.0 - opacity));
}


void main()
{
    vec4 coordinate=vec4(textureCoordinate, 0., 1.);
    coordinate= mBlendMatrix * coordinate;
    if (coordinate.x<0.||coordinate.x>1.||coordinate.y<0.||coordinate.y>1.){
        gl_FragColor=texture2D(inputImageTexture, textureCoordinate);
        return;
    }
    mediump vec4 blendColor = texture2D(inputImageTexture2, coordinate.xy) ;
    mediump vec4 maskColor= vec4(0.0);
    if (frontBackType != 0){
        maskColor=texture2D(inputImageTexture3, textureCoordinate);
    }
    mediump vec4 srcColor = texture2D(inputImageTexture, textureCoordinate);

    if(showBlendInTranslparent == 0){
        blendColor =  blendColor * srcColor.a ;
    }
    float alpha= 1.- maskColor.a;
    blendColor = blendColor  * alpha;

    gl_FragColor= vec4(blendSoftLight(srcColor.rgb,blendColor.rgb,intensity * alpha),srcColor.a);

}