////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform highp float iTime;

vec4 lookupBlend(vec2  uv, sampler2D inputImage) {
    uv.y *= 0.6666 ;
    highp vec4 textureColor = texture2D(inputImageTexture, uv);
    if (textureColor.a == 0.0){
        return vec4(0.0);
    }
    highp float blueColor = textureColor.b * 63.0;

    highp vec2 quad1;
    quad1.y = floor(floor(blueColor) / 8.0);
    quad1.x = floor(blueColor) - (quad1.y * 8.0);

    highp vec2 quad2;
    quad2.y = floor(ceil(blueColor) / 8.0);
    quad2.x = ceil(blueColor) - (quad2.y * 8.0);

    highp vec2 texPos1;
    texPos1.x = (quad1.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.r);
    texPos1.y = (quad1.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.g);

    highp vec2 texPos2;
    texPos2.x = (quad2.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.r);
    texPos2.y = (quad2.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.g);

    lowp vec4 newColor1 = texture2D(inputImage, texPos1);
    lowp vec4 newColor2 = texture2D(inputImage, texPos2);

    lowp vec4 newColor = mix(newColor1, newColor2, fract(blueColor));

    return newColor;
}

void main() {
    highp vec2 uv = textureCoordinate;
    vec4 newColor;
    if ((uv.x< 0.5 && uv.y <0.3333)
    || (uv.x >0.5 && uv.y >0.3333 && uv.y <0.6666)
    || (uv.x <0.5 && uv.y >0.6666)){
        uv.x *= 2.0;
        uv.y *= 3.0 ;
        //        vec4 textureColor = texture2D(inputImageTexture, fract(uv));
        newColor = lookupBlend(fract(uv), inputImageTexture2);
    } else {
        uv.x *= 2.0;
        uv.y *= 3.0;
        //        vec4 textureColor = texture2D(inputImageTexture, fract(uv));
        newColor = lookupBlend(fract(uv), inputImageTexture3);
    }
    gl_FragColor = newColor;
}