////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform int mNeedDrawBound;
uniform float mContralColor[6];
uniform mat4 mBlendMatrix;
uniform lowp float intensity;
const float off = 0.1;
const float threshold = 0.002;
uniform int antiType;

bool isControlColor(vec4 contralAreaTexture){
    return abs(contralAreaTexture.r - mContralColor[0])< off && abs(contralAreaTexture.g - mContralColor[1])<off
    &&  abs(contralAreaTexture.b - mContralColor[2]) <off;
}

bool isBorderColor(vec4 contralAreaTexture){
    return abs(contralAreaTexture.r - mContralColor[3])< off && abs(contralAreaTexture.g - mContralColor[4])<off
    &&  abs(contralAreaTexture.b - mContralColor[5]) <off;
}

void main() {
    vec4 coordinate = vec4(textureCoordinate, 0., 1.);

    mediump vec4 srcColor = texture2D(inputImageTexture, textureCoordinate);
    coordinate = mBlendMatrix * coordinate;
    if (coordinate.x < 0. || coordinate.x > 1. || coordinate.y < 0. || coordinate.y > 1.) {
        if(mNeedDrawBound == 1 ){
            mediump vec4 contralAreaTexture = texture2D(inputImageTexture3, textureCoordinate) ;
            if(contralAreaTexture.a >0.999){
                vec3 borderColor = vec3(mContralColor[3],mContralColor[4],mContralColor[5]);
                gl_FragColor = vec4(srcColor.rgb * (1.0 - contralAreaTexture.a) + borderColor.rgb,max(srcColor.a,srcColor.a * (1.0 - contralAreaTexture.a) + contralAreaTexture.a));
            }else if(contralAreaTexture.a >0.0){
                gl_FragColor =   vec4(srcColor.rgb * (1.0 - contralAreaTexture.a) + contralAreaTexture.rgb,max(srcColor.a,srcColor.a * (1.0 - contralAreaTexture.a) + contralAreaTexture.a));
            }else{
                gl_FragColor =  srcColor;
            }

        }else{
            gl_FragColor =  srcColor;
        }

        return;
    }
    mediump vec4 pipColor = texture2D(inputImageTexture2, coordinate.xy) * intensity;




    if(mNeedDrawBound == 1 ){
        mediump vec4 contralAreaTexture = texture2D(inputImageTexture3, textureCoordinate) ;
        if(isControlColor(contralAreaTexture)){
            pipColor = pipColor * contralAreaTexture.a;
        }else{
            if(contralAreaTexture.a < 1.0 || isBorderColor(contralAreaTexture)){
                pipColor = contralAreaTexture;
            }else {
                if(mContralColor[0] <0.1){
                    pipColor = vec4(pipColor.rgb * (1.0 - contralAreaTexture.r * pipColor.a )
                    + vec3(mContralColor[3],mContralColor[4],mContralColor[5]) * pipColor.a * contralAreaTexture.r,pipColor.a );
                }else{
                    pipColor = vec4(pipColor.rgb *  contralAreaTexture.r *pipColor.a
                    + vec3(mContralColor[3],mContralColor[4],mContralColor[5]) * pipColor.a*  (1.0 - contralAreaTexture.r *pipColor.a ),pipColor.a );
                }
            }

        }
    }else if(mNeedDrawBound == 2){
        mediump vec4 contralAreaTexture = texture2D(inputImageTexture3, textureCoordinate) ;
        pipColor = pipColor * contralAreaTexture.a;
    }else {
        if (antiType != 0){
            float parms = threshold;
            if (abs(coordinate.x) < threshold){
                parms = abs(coordinate.x);
            }else if(abs(coordinate.x - 1.0) <threshold){
                parms = abs(coordinate.x- 1.0);
            }else if(abs(coordinate.y) <threshold){
                parms = abs(coordinate.y);
            }else if(abs(coordinate.y-1.0) <threshold){
                parms = abs(coordinate.y-1.0);
            }
            parms = parms/threshold;
            pipColor = pipColor * parms;
        }
    }
    gl_FragColor = vec4(srcColor.rgb * (1.0 - pipColor.a)+ pipColor.rgb,max(srcColor.a,srcColor.a * (1.0 - pipColor.a) + pipColor.a));
    //    gl_FragColor = pipColor;
}