////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

uniform mat4 mBlendMatrix;
uniform lowp vec4 destColor;

void main() {
    vec4 coordinate = vec4(textureCoordinate, 0., 1.);
    coordinate = mBlendMatrix * coordinate;
    if (coordinate.x < 0. || coordinate.x > 1. || coordinate.y < 0. || coordinate.y > 1.) {
        gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
        return;
    }
    mediump vec4 maskColor = texture2D(inputImageTexture2, coordinate.xy);
    //改为目标颜色
    maskColor = vec4(destColor.rgb * maskColor.a * destColor.a, maskColor.a * destColor.a);
    mediump vec4 srcColor = texture2D(inputImageTexture, textureCoordinate);
    //透明部分转变为黑色
    srcColor = vec4(srcColor.rgb, 1.);
    gl_FragColor = srcColor * (1.0 - maskColor.a) + maskColor;
}